'use strict';

var SolicitacaoServices = angular.module('SolicitacaoServices', []);

SolicitacaoServices.factory('Solicitacao', ['Conexao',
    (Conexao) => {

    var solicitacaoFactory = {};

    solicitacaoFactory.setSolicitacao = (solicitacao, callBackFunction) => {
        Conexao.ExecutaService('setSolicitacao', solicitacao, true,
            (data) => {
                callBackFunction(data);
            });
    }

    solicitacaoFactory.delSolicitacao = (IdSolicitacao, callBackFunction) => {
        Conexao.ExecutaService('delSolicitacao', { IdSolicitacao: IdSolicitacao }, true,
            (data) => {
                callBackFunction(data);
            });
    }

    solicitacaoFactory.getSolicitacoes = (params, callBackFunction) => {
        Conexao.ExecutaService('getSolicitacoes', params, false,
            (data) => {
                callBackFunction(data);
            });
    }

    solicitacaoFactory.getSolicitacoesFiltro = (params, callBackFunction) => {
        Conexao.ExecutaService('getSolicitacoesFiltro', params, false,
            (data) => {
                callBackFunction(data);
            });
    }

    solicitacaoFactory.getSolicitacaoSituacao = (callBackFunction) => {
        Conexao.ExecutaService('getSolicitacaoSituacao', {}, false,
            (data) => {
                callBackFunction(data);
            });
    }
    
    solicitacaoFactory.setSolicitacaoWorkflow = (SolicitacaoWorkflow, callBackFunction) => {
        Conexao.ExecutaService('setSolicitacaoWorkflow', SolicitacaoWorkflow, true,
            (data) => {
                callBackFunction(data);
            });
    }

    solicitacaoFactory.delSolicitacaoWorkFlow = (IdSolicitacaoWorkflow, callBackFunction) => {
        Conexao.ExecutaService('delSolicitacaoWorkFlow', { IdSolicitacaoWorkflow: IdSolicitacaoWorkflow }, true,
            (data) => {
                callBackFunction(data);
            });
    }

    solicitacaoFactory.getSolicitacaoWorkflow = (IdSolicitacao, callBackFunction) => {
        Conexao.ExecutaService('getSolicitacaoWorkflow', { IdSolicitacao: IdSolicitacao }, false,
            (data) => {
                callBackFunction(data);
            });
    }

    solicitacaoFactory.getSolicitacaoAuditoria = (IdSolicitacao, callBackFunction) => {
        Conexao.ExecutaService('getSolicitacaoAuditoria', { IdSolicitacao: IdSolicitacao }, false,
            (data) => {
                callBackFunction(data);
            });
    }

    solicitacaoFactory.setSolicitacaoItem = (item, callBackFunction) => {
        Conexao.ExecutaService('setSolicitacaoItem', item, true,
            (data) => {
                callBackFunction(data);
            });
    }

    solicitacaoFactory.delSolicitacaoItem = (IdSolicitacaoItem, callBackFunction) => {
        Conexao.ExecutaService('delSolicitacaoItem', { IdSolicitacaoItem: IdSolicitacaoItem }, true,
            (data) => {
                callBackFunction(data);
            });
    }

    solicitacaoFactory.getSolicitacaoItem = (params, callBackFunction) => {
        Conexao.ExecutaService('getSolicitacaoItem', params, false,
            (data) => {
                callBackFunction(data);
            });
    }

    // solicitacaoFactory.setSolicitacaoListaItens = (solicitacaoItens, callBackFunction) => {
    //     Conexao.ExecutaService('setSolicitacaoListaItens', { solicitacaoItensJson: JSON.stringify(solicitacaoItens) }, true,
    //         (data) => {
    //             callBackFunction(data);
    //         });
    // }

    solicitacaoFactory.setSolicitacaoListaItens = (solicitacaoItens, callBackFunction) => {
        var params = {
            POST: true,
            data: solicitacaoItens
        }
        Conexao.ExecutaService('postSolicitacaoListaItens', params, true,
            (data) => {
                callBackFunction(data);
            });
    }

    solicitacaoFactory.pdfOrdemCompra = function (IdSolicitacao, IdFornecedor, cabecalho, callBackFunction) {
        Conexao.ExecutaService('pdfOrdemCompra', { IdSolicitacao: IdSolicitacao, IdFornecedor: IdFornecedor, Cabecalho: JSON.stringify(cabecalho) }, true,
            (data) => {
                callBackFunction(data);
            });
    }

    solicitacaoFactory.getRelatorioCompras = (params, callBackFunction) => {
        Conexao.ExecutaService('getRelatorioCompras', params, true,
            (data) => {
                callBackFunction(data);
            });
    }

    solicitacaoFactory.pdfRelatorioCompras = (params, callBackFunction) => {
        Conexao.ExecutaService('pdfRelatorioCompras', params, true,
            (data) => {
                callBackFunction(data);
            });
    }

    solicitacaoFactory.xlsRelatorioCompras = (params, callBackFunction) => {
        Conexao.ExecutaService('xlsRelatorioCompras', params, true,
            (data) => {
                callBackFunction(data);
            });
    }

    solicitacaoFactory.pdfSolicitacaoItem = (params, callBackFunction) => {
        Conexao.ExecutaService('pdfSolicitacaoItem', params, true,
            (data) => {
                callBackFunction(data);
            });
    }

    solicitacaoFactory.xlsSolicitacaoItem = (params, callBackFunction) => {
        Conexao.ExecutaService('xlsSolicitacaoItem', params, true,
            (data) => {
                callBackFunction(data);
            });
    }

    solicitacaoFactory.setSolicitacaoItensNaoCotados = (itens, callBackFunction) => {
        var params = {
            POST: true,
            data: itens
        }

        Conexao.ExecutaService('setSolicitacaoItensNaoCotados', params, true,
            (data) => {
                callBackFunction(data);
            });
    }

    solicitacaoFactory.getRelatorioEntregas = (params, callBackFunction) => {
        Conexao.ExecutaService('getRelatorioEntregas', params, true,
            (data) => {
                callBackFunction(data);
            });
    }

    solicitacaoFactory.pdfRelatorioEntregas = (params, callBackFunction) => {
        Conexao.ExecutaService('pdfRelatorioEntregas', params, true,
            (data) => {
                callBackFunction(data);
            });
    }

    solicitacaoFactory.xlsRelatorioEntregas = (params, callBackFunction) => {
        Conexao.ExecutaService('xlsRelatorioEntregas', params, true,
            (data) => {
                callBackFunction(data);
            });
    }

    return solicitacaoFactory;

  }]);
